//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <IniFiles.hpp>
#include <StrUtils.hpp>


#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;


__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
   pIni = new TIniFile( ChangeFileExt( ParamStr(0), ".ini" ) );
   LastUsedString = pIni->ReadString("Last Used Items", "String", "" );

   GoAddStringToListBox( ListBox1, LastUsedString );

   ComboBox1->Items->Assign( ListBox1->Items );

   if ( ComboBox1->Items->Count > 0 )
      ComboBox1->ItemIndex = 0;

   delete pIni;
}
__fastcall TForm1::~TForm1()
{
   pIni = new TIniFile( ChangeFileExt( ParamStr(0), ".ini" ) );

   LastUsedString = GoGetListBoxToString( ListBox1 );

   pIni->WriteString("Last Used Items", "String", LastUsedString );
   delete pIni;
}

void __fastcall TForm1::UpButtonClick(TObject *Sender)
{
   ListBox1->SetFocus();
   if (  ListBox1->ItemIndex == -1 )
      return;

   int up = ListBox1->ItemIndex;
   if ( ListBox1->ItemIndex > 0 )
   {
      ListBox1->Items->Move( ListBox1->ItemIndex, ListBox1->ItemIndex-1 );
      --up;
   }
   ListBox1->Repaint();
   ListBox1->SetFocus();
   ListBox1->ItemIndex = up;
}

void __fastcall TForm1::DownButtonClick(TObject *Sender)
{
   ListBox1->SetFocus();
   if (  ListBox1->ItemIndex == -1 )
      return;
   int dw = ListBox1->ItemIndex;
   if ( ListBox1->ItemIndex < ( ListBox1->Items->Count - 1 ) )
   {
      ListBox1->Items->Move( ListBox1->ItemIndex, ListBox1->ItemIndex+1 );
      ++dw;
   }
   ListBox1->Repaint();
   ListBox1->SetFocus();
   ListBox1->ItemIndex = dw;
}

void __fastcall TForm1::EditButtonClick(TObject *Sender)
{
   ListBox1->SetFocus();
   if (  ListBox1->ItemIndex == -1 )
      return;


   AnsiString Text = ListBox1->Items->Strings[ ListBox1->ItemIndex ];
   AnsiString Default = Text;

   bool result = InputQuery( "Edit", "Change the value", Text );

   if ( result )
   {
      if ( ( Text == Default ) || ( Text == "" ) || ( strchr( Text.c_str(), ';' ) ) )
         return;

      if ( ListBox1->Items->IndexOf( Text ) != -1 )
         return;

      ListBox1->Items->Strings[ ListBox1->ItemIndex ] = Trim ( Text );

      SNDMSG( ListBox1->Handle, WM_VSCROLL, SB_BOTTOM, 0 );

   }


}

void __fastcall TForm1::NewButtonClick(TObject *Sender)
{
   ListBox1->SetFocus();

   AnsiString Text = "";

   bool result = InputQuery( "New", "Enter new value", Text );


   if ( result )
   {
      if ( ( Text == "" ) || ( strchr( Text.c_str(), ';' ) ) )
         return;

      if ( ListBox1->Items->IndexOf( Text ) != -1 )
         return;

      ListBox1->Items->Add( Trim( Text ) );
      SNDMSG( ListBox1->Handle, WM_VSCROLL, SB_BOTTOM, 0 );

   }

   if ( ListBox1->Count > 0 )
      if ( ListBox1->ItemIndex == -1 )
         ListBox1->ItemIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DeleteButtonClick(TObject *Sender)
{
   ListBox1->SetFocus();
   if (  ListBox1->ItemIndex == -1 )
      return;
   int re = ListBox1->ItemIndex;

   if ( MessageDlg( "Delete\n" + ListBox1->Items->Strings[ ListBox1->ItemIndex ] + " ?",
               mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0 ) == mbYes )


   {
       ListBox1->Items->Delete( ListBox1->ItemIndex );
   }
   ListBox1->Repaint();
   ListBox1->SetFocus();
   if ( re > ListBox1->Items->Count - 1 )
   {
      ListBox1->ItemIndex = --re;
   }
   else
   {
      ListBox1->ItemIndex = re;
   }

   if ( ListBox1->Count > 0 )
      if ( ListBox1->ItemIndex == -1 )
         ListBox1->ItemIndex = 0;

}

AnsiString TForm1::GoGetListBoxToString( TListBox *LB )
{
   AnsiString OT;
   for ( int i = 1; i <= LB->Items->Count; i++ )
      OT += LB->Items->Strings[ i-1 ] + ";";

   // Eliminate last ';'
   OT.SetLength( OT.Length() - 1 );
   return( OT );
}

void TForm1::GoAddStringToListBox( TListBox *LB, AnsiString STRING )
{
   STRING = STRING + ";";
   int length  = STRING.Length();

   LB->Clear();

   if ( length != 1 )
   {
      char *niz     = new char[ length+1 ];
      char *pom     = new char[ length+1 ];

      strcpy( niz, STRING.c_str() );

      int prev = 0;
      for ( int i=0;  i<length; i++ )
      {
         if ( niz[i] == ';' || i == length-1 )
         {
            strncpy( pom, &niz[prev], i-prev );
            pom[i-prev]  = '\0';
            LB->Items->Add( Trim( AnsiString( pom ) ) );
            prev = i+1;
         }
      }

      delete [] pom;
      delete [] niz;
   }

   if ( LB->Count > 0 )
      if ( LB->ItemIndex == -1 ) LB->ItemIndex = 0;

}


void __fastcall TForm1::UpdateButtonClick(TObject *Sender)
{
   ComboBox1->Items->Assign( ListBox1->Items );

   if ( ComboBox1->Items->Count > 0 )
      ComboBox1->ItemIndex = 0;
}

